<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 7.1: Standard Input and Output</title>
<link href="sx10.html" rev=precedes>
<link href="sx10b.html" rel=precedes>
<link href="sx10.html" rev=subdocument>
</head>
<body>
<H2>section 7.1: Standard Input and Output</H2>

<p>Note that ``a text stream'' might refer
to input
(to the program)
from the keyboard or output to the screen,
<em>or</em>
input and output from files on disk.
(For that matter,
it can also refer to input and output from other peripheral devices,
or the network.)
</p><p>Note that the stdio library generally does newline translation for you.
If you know that lines are terminated by a linefeed on Unix 
and a carriage return on the Macintosh and a 
carriage-return/linefeed combination on MS-DOS, you don't have 
to worry about these things in C, because the line termination 
will always appear to a C program to be a single <TT>'\n'</TT>.
(That is, when reading,
a single <TT>'\n'</TT> represents the end of the line being read,
and when writing,
writing a <TT>'\n'</TT> causes
the underlying system's actual end-of-line representation to be written.)
</p><p>pages 152-153
</p><p>The ``<TT>lower</TT>'' program is an example of a <dfn>filter</dfn>:
it reads its standard input,
``filters''
(that is, processes)
it in some way, and writes the result to its standard output.
Filters are designed for
(and are only really useful under)
a command-line interface such as the Unix shells
or the
MS-DOS command.com interface.
Obviously, you would rarely invoke a program like <TT>lower</TT>
by itself, because you would have to type the input text at it
and you could only see the output ephemerally on your screen.
To do any real work, you would always redirect the input:
<pre>	lower &lt; inputfile
</pre>and perhaps the output:
<pre>	lower &lt; inputfile &gt; outputfile
</pre>(notice that spaces may precede and follow
the <TT>&lt;</TT> and <TT>&gt;</TT> characters).
Or, a filter program like <TT>lower</TT> might appear in a longer 
pipeline:
<pre>	oneprogram | lower | anotherprogram
or
	anotherprogram &lt; inputfile | lower | thirdprogram &gt; outputfile
</pre>Filters like these are not terribly useful,
though,
under a Graphical User Interface
such as the Macintosh or Microsoft Windows.
</p><hr>
<p>
Read sequentially:
<a href="sx10.html" rev=precedes>prev</a>
<a href="sx10b.html" rel=precedes>next</a>
<a href="sx10.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
